using Microsoft.EntityFrameworkCore;
using NetinaShop.Domain.Entities.Brands;

namespace NetinaShop.Repository.Handlers.Brands;

public class DeleteBrandCommandHandler : IRequestHandler<DeleteBrandCommand,bool>
{
    private readonly IRepositoryWrapper _repositoryWrapper;

    public DeleteBrandCommandHandler(IRepositoryWrapper repositoryWrapper)
    {
        _repositoryWrapper = repositoryWrapper;
    }
    public async Task<bool> Handle(DeleteBrandCommand request, CancellationToken cancellationToken)
    {
        var ent = await _repositoryWrapper.SetRepository<Brand>().TableNoTracking
            .FirstOrDefaultAsync(b => b.Id == request.Id, cancellationToken);
        if (ent == null)
            throw new AppException("Brand not found");
        _repositoryWrapper.SetRepository<Brand>().Delete(ent);
        await _repositoryWrapper.SaveChangesAsync(cancellationToken);

        return true;
    }
}